From ead3ed70fd9f0a43f841c43845fa385f55929213 Mon Sep 17 00:00:00 2001
From: Daan De Meyer <daan.j.demeyer@gmail.com>
Date: Jan 20 2022 16:52:29 +0000
Subject: [PATCH 13/15] journal: Add boot ID deduplication in compact mode


sd_id128_t objects take up 16 bytes per entry object.
If we replace them with an offset to a boot id object,
we reduce the overhead to 4 bytes per entry. On top of
this, the change allows us to make the trie_offset field
32-bit as well. In total, this allows us to save 16 bytes
per Entry object.

Before:

SYSTEMD_JOURNAL_NON_INDEXED_FIELDS="_CAP_EFFECTIVE _PID _UID _GID _SELINUX_CONTEXT _SOURCE_REALTIME_TIMESTAMP _MACHINE_ID _HOSTNAME _STREAM_ID _LINE_BREAK SYSLOG_FACILITY SYSLOG_IDENTIFIER _COMM _CMDLINE _EXE _SYSTEMD_INVOCATION_ID"

OBJECT TYPE	 ENTRIES SIZE
Unused           0	 0B
Data             987596  92.5M
Field            2127    114.8K
Entry            3500464 667.8M
Data Hash Table  9	 32.0M
Field Hash Table 9	 46.9K
Entry Array	 241932  200.3M
Tag              0	 0B
Trie Node        1752229 66.8M
Trie Hash Table  9	 47.9M
Total            6484375 1.0G

After:

SYSTEMD_JOURNAL_NON_INDEXED_FIELDS="_CAP_EFFECTIVE _PID _UID _GID _SELINUX_CONTEXT _SOURCE_REALTIME_TIMESTAMP _MACHINE_ID _HOSTNAME _STREAM_ID _LINE_BREAK SYSLOG_FACILITY SYSLOG_IDENTIFIER _COMM _CMDLINE _EXE _SYSTEMD_INVOCATION_ID"

OBJECT TYPE      ENTRIES SIZE
Unused           0       0B
Data             985433  92.3M
Field            2142    115.7K
Entry            3500812 614.4M
Data Hash Table  9       32.0M
Field Hash Table 9       46.9K
Entry Array      240841  191.2M
Tag              0       0B
Trie Node        1752652 66.8M
Trie Hash Table  9       47.9M
Boot ID          55      1.7K
Total            6481962 1.0G

---

diff --git a/src/journal/test-journal.c b/src/journal/test-journal.c
index 3afe66d..549889b 100644
--- a/src/journal/test-journal.c
+++ b/src/journal/test-journal.c
@@ -31,7 +31,7 @@ static void test_non_empty(void) {
         static const char test[] = "TEST1=1", test2[] = "TEST2=2";
         Object *o;
         uint64_t p;
-        sd_id128_t fake_boot_id;
+        sd_id128_t fake_boot_id, boot_id;
         char t[] = "/var/tmp/journal-XXXXXX";
 
         test_setup_logging(LOG_DEBUG);
@@ -68,7 +68,8 @@ static void test_non_empty(void) {
 
         assert_se(journal_file_next_entry(f->file, p, DIRECTION_DOWN, &o, &p) == 1);
         assert_se(le64toh(o->entry.seqnum) == 3);
-        assert_se(sd_id128_equal(o->entry.boot_id, fake_boot_id));
+        assert_se(journal_file_entry_boot_id(f->file, o, &boot_id) == 0);
+        assert_se(sd_id128_equal(boot_id, fake_boot_id));
 
         assert_se(journal_file_next_entry(f->file, p, DIRECTION_DOWN, &o, &p) == 0);
 
diff --git a/src/libsystemd/sd-journal/journal-def.h b/src/libsystemd/sd-journal/journal-def.h
index eef3f46..7533e93 100644
--- a/src/libsystemd/sd-journal/journal-def.h
+++ b/src/libsystemd/sd-journal/journal-def.h
@@ -24,6 +24,7 @@ typedef struct HashTableObject HashTableObject;
 typedef struct EntryArrayObject EntryArrayObject;
 typedef struct TagObject TagObject;
 typedef struct TrieNodeObject TrieNodeObject;
+typedef struct BootIdObject BootIdObject;
 
 typedef struct EntryItem EntryItem;
 typedef struct HashItem HashItem;
@@ -42,6 +43,7 @@ typedef enum ObjectType {
         OBJECT_TAG,
         OBJECT_TRIE_NODE,
         OBJECT_TRIE_HASH_TABLE,
+        OBJECT_BOOT_ID,
         _OBJECT_TYPE_MAX
 } ObjectType;
 
@@ -105,20 +107,24 @@ typedef struct {
         bool indexed;
 } EntryItemEx;
 
-#define EntryObject__contents {                \
-        ObjectHeader object;                   \
-        le64_t seqnum;                         \
-        le64_t realtime;                       \
-        le64_t monotonic;                      \
-        sd_id128_t boot_id;                    \
-        le64_t xor_hash;                       \
-        union {                                \
-                EntryItem items[0];            \
-                struct {                       \
-                        le64_t trie_offset;    \
-                        uint8_t payload[];     \
-                };                             \
-        };                                     \
+#define EntryObject__contents {                  \
+        ObjectHeader object;                     \
+        le64_t seqnum;                           \
+        le64_t realtime;                         \
+        le64_t monotonic;                        \
+        union {                                  \
+                struct {                         \
+                        sd_id128_t boot_id;      \
+                        le64_t xor_hash;         \
+                        EntryItem items[];       \
+                };                               \
+                struct {                         \
+                        le64_t xor_hash_compact; \
+                        le32_t boot_id_offset;   \
+                        le32_t trie_offset;      \
+                        uint8_t payload[];       \
+                };                               \
+        };                                       \
 }
 
 struct EntryObject EntryObject__contents;
@@ -165,6 +171,15 @@ struct TrieNodeObject TrieNodeObject__contents;
 struct TrieNodeObject__packed TrieNodeObject__contents _packed_;
 assert_cc(sizeof(struct TrieNodeObject) == sizeof(struct TrieNodeObject__packed));
 
+#define BootIdObject__contents { \
+        ObjectHeader object;     \
+        sd_id128_t value;        \
+}
+
+struct BootIdObject BootIdObject__contents;
+struct BootIdObject__packed BootIdObject__contents _packed_;
+assert_cc(sizeof(struct BootIdObject) == sizeof(struct BootIdObject__packed));
+
 union Object {
         ObjectHeader object;
         DataObject data;
@@ -174,6 +189,7 @@ union Object {
         EntryArrayObject entry_array;
         TagObject tag;
         TrieNodeObject trie_node;
+        BootIdObject boot_id;
 };
 
 enum {
@@ -259,12 +275,13 @@ enum {
         le64_t trie_hash_table_size;                    \
         le64_t n_trie_nodes;                            \
         le64_t trie_hash_chain_depth;                   \
+        le64_t boot_id_offset;                          \
         }
 
 struct Header struct_Header__contents;
 struct Header__packed struct_Header__contents _packed_;
 assert_cc(sizeof(struct Header) == sizeof(struct Header__packed));
-assert_cc(sizeof(struct Header) == 288);
+assert_cc(sizeof(struct Header) == 296);
 
 #define FSS_HEADER_SIGNATURE                                            \
         ((const char[]) { 'K', 'S', 'H', 'H', 'R', 'H', 'L', 'P' })
diff --git a/src/libsystemd/sd-journal/journal-file.c b/src/libsystemd/sd-journal/journal-file.c
index 3a8d541..6333709 100644
--- a/src/libsystemd/sd-journal/journal-file.c
+++ b/src/libsystemd/sd-journal/journal-file.c
@@ -286,7 +286,34 @@ static int journal_file_init_header(JournalFile *f, JournalFile *template) {
         return 0;
 }
 
+static int journal_file_refresh_boot_id(JournalFile *f, const sd_id128_t *boot_id) {
+        Object *o;
+        uint64_t p;
+        int r;
+
+        assert(boot_id);
+
+        if (!JOURNAL_HEADER_COMPACT(f->header)) {
+                f->header->boot_id = *boot_id;
+                return 0;
+        }
+
+        if (sd_id128_equal(*boot_id, f->header->boot_id) && le64toh(f->header->boot_id_offset) > 0)
+                return 0;
+
+        r = journal_file_append_object(f, OBJECT_BOOT_ID, sizeof(BootIdObject), &o, &p);
+        if (r < 0)
+                return r;
+
+        o->boot_id.value = *boot_id;
+        f->header->boot_id_offset = htole64(p);
+        f->header->boot_id = *boot_id;
+
+        return 0;
+}
+
 static int journal_file_refresh_header(JournalFile *f) {
+        sd_id128_t boot_id;
         int r;
 
         assert(f);
@@ -299,7 +326,11 @@ static int journal_file_refresh_header(JournalFile *f) {
         else if (r < 0)
                 return r;
 
-        r = sd_id128_get_boot(&f->header->boot_id);
+        r = sd_id128_get_boot(&boot_id);
+        if (r < 0)
+                return r;
+
+        r = journal_file_refresh_boot_id(f, &boot_id);
         if (r < 0)
                 return r;
 
@@ -2014,7 +2045,7 @@ static int journal_file_entry_item_next_compact(
         if (sz < offsetof(Object, entry.payload))
                 return -EBADMSG;
 
-        p = *i == 0 ? le64toh(READ_NOW(e->entry.trie_offset)) : *i;
+        p = *i == 0 ? le32toh(READ_NOW(e->entry.trie_offset)) : *i;
 
         /* All of an entry's trie and data nodes are located before the entry object in the journal file. */
         if (p > offset + sz)
@@ -2157,6 +2188,26 @@ int journal_file_entry_item_next(
                         f, e, offset, i, field, field_length, data_threshold, ret_offset, ret_data, ret_size);
 }
 
+uint64_t journal_file_entry_xor_hash(JournalFile *f, Object *o) {
+        return JOURNAL_HEADER_COMPACT(f->header) ? le64toh(o->entry.xor_hash_compact) :
+                                                   le64toh(o->entry.xor_hash);
+}
+
+int journal_file_entry_boot_id(JournalFile *f, Object *o, sd_id128_t *ret_boot_id) {
+        int r;
+
+        if (JOURNAL_HEADER_COMPACT(f->header)) {
+                r = journal_file_move_to_object(f, OBJECT_BOOT_ID, le32toh(o->entry.boot_id_offset), &o);
+                if (r < 0)
+                        return r;
+
+                *ret_boot_id = o->boot_id.value;
+        } else
+                *ret_boot_id = o->entry.boot_id;
+
+        return 0;
+}
+
 uint64_t journal_file_entry_array_n_items(JournalFile *f, Object *o) {
         uint64_t sz;
 
@@ -2519,7 +2570,7 @@ static int journal_file_append_entry_internal(
 
         if (JOURNAL_HEADER_COMPACT(f->header)) {
                 uint8_t *p = o->entry.payload;
-                o->entry.trie_offset = htole64(parent_offset);
+                o->entry.trie_offset = htole32(parent_offset);
 
                 for (unsigned i = 0; i < n_inlined; i++) {
                         int compression = 0;
@@ -2552,10 +2603,20 @@ static int journal_file_append_entry_internal(
 
         o->entry.realtime = htole64(ts->realtime);
         o->entry.monotonic = htole64(ts->monotonic);
-        o->entry.xor_hash = htole64(xor_hash);
-        if (boot_id)
-                f->header->boot_id = *boot_id;
-        o->entry.boot_id = f->header->boot_id;
+
+        if (boot_id) {
+                r = journal_file_refresh_boot_id(f, boot_id);
+                if (r < 0)
+                        return r;
+        }
+
+        if (JOURNAL_HEADER_COMPACT(f->header)) {
+                o->entry.xor_hash_compact = htole64(xor_hash);
+                o->entry.boot_id_offset = htole32(le64toh(f->header->boot_id_offset));
+        } else {
+                o->entry.xor_hash = htole64(xor_hash);
+                o->entry.boot_id = f->header->boot_id;
+        }
 
 #if HAVE_GCRYPT
         r = journal_file_hmac_put_object(f, OBJECT_ENTRY, o, np);
@@ -3455,14 +3516,21 @@ void journal_file_reset_location(JournalFile *f) {
         f->current_xor_hash = 0;
 }
 
-void journal_file_save_location(JournalFile *f, Object *o, uint64_t offset) {
+int journal_file_save_location(JournalFile *f, Object *o, uint64_t offset) {
+        int r;
+
+        r = journal_file_entry_boot_id(f, o, &f->current_boot_id);
+        if (r < 0)
+                return r;
+
         f->location_type = LOCATION_SEEK;
         f->current_offset = offset;
         f->current_seqnum = le64toh(o->entry.seqnum);
         f->current_realtime = le64toh(o->entry.realtime);
         f->current_monotonic = le64toh(o->entry.monotonic);
-        f->current_boot_id = o->entry.boot_id;
-        f->current_xor_hash = le64toh(o->entry.xor_hash);
+        f->current_xor_hash = journal_file_entry_xor_hash(f, o);
+
+        return 0;
 }
 
 int journal_file_compare_locations(JournalFile *af, JournalFile *bf) {
@@ -4414,7 +4482,7 @@ int journal_file_dispose(int dir_fd, const char *fname) {
 
 int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint64_t p) {
         size_t n = 0;
-        const sd_id128_t *boot_id;
+        sd_id128_t boot_id;
         dual_timestamp ts;
         EntryItemEx *items;
         struct iovec *inlined;
@@ -4433,7 +4501,10 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
                 .monotonic = le64toh(o->entry.monotonic),
                 .realtime = le64toh(o->entry.realtime),
         };
-        boot_id = &o->entry.boot_id;
+
+        r = journal_file_entry_boot_id(from, o, &boot_id);
+        if (r < 0)
+                return r;
 
         for (uint64_t i = 0;;) {
                 r = journal_file_entry_item_next(from, o, p, &i, NULL, 0, 0, NULL, NULL, NULL);
@@ -4501,7 +4572,7 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
         }
 
         r = journal_file_append_entry_internal(
-                to, &ts, boot_id, items, n_items, inlined, n_inlined, NULL, NULL, NULL);
+                to, &ts, &boot_id, items, n_items, inlined, n_inlined, NULL, NULL, NULL);
 
 finish:
         for (size_t i = 0; i < n_inlined; i++)
@@ -4775,6 +4846,7 @@ static const char * const journal_object_type_table[] = {
         [OBJECT_TAG] = "tag",
         [OBJECT_TRIE_NODE] = "trie node",
         [OBJECT_TRIE_HASH_TABLE] = "trie hash table",
+        [OBJECT_BOOT_ID] = "boot id",
 };
 
 DEFINE_STRING_TABLE_LOOKUP_TO_STRING(journal_object_type, ObjectType);
diff --git a/src/libsystemd/sd-journal/journal-file.h b/src/libsystemd/sd-journal/journal-file.h
index 6fc3632..9b9b72d 100644
--- a/src/libsystemd/sd-journal/journal-file.h
+++ b/src/libsystemd/sd-journal/journal-file.h
@@ -217,6 +217,9 @@ int journal_file_entry_item_next(
                 void **ret_data,
                 size_t *ret_size);
 
+uint64_t journal_file_entry_xor_hash(JournalFile *f, Object *o);
+int journal_file_entry_boot_id(JournalFile *f, Object *o, sd_id128_t *ret_boot_id);
+
 uint64_t journal_file_entry_array_n_items(JournalFile *f, Object *o) _pure_;
 uint64_t journal_file_entry_array_item(JournalFile *f, Object *o, size_t i) _pure_;
 uint64_t journal_file_hash_table_n_items(Object *o) _pure_;
@@ -238,7 +241,7 @@ int journal_file_find_field_object(JournalFile *f, const void *field, uint64_t s
 int journal_file_find_field_object_with_hash(JournalFile *f, const void *field, uint64_t size, uint64_t hash, Object **ret, uint64_t *offset);
 
 void journal_file_reset_location(JournalFile *f);
-void journal_file_save_location(JournalFile *f, Object *o, uint64_t offset);
+int journal_file_save_location(JournalFile *f, Object *o, uint64_t offset);
 int journal_file_compare_locations(JournalFile *af, JournalFile *bf);
 int journal_file_next_entry(JournalFile *f, uint64_t p, direction_t direction, Object **ret, uint64_t *offset);
 
diff --git a/src/libsystemd/sd-journal/journal-verify.c b/src/libsystemd/sd-journal/journal-verify.c
index d286f98..6ff25fb 100644
--- a/src/libsystemd/sd-journal/journal-verify.c
+++ b/src/libsystemd/sd-journal/journal-verify.c
@@ -1105,7 +1105,9 @@ int journal_file_verify(
                         n_fields++;
                         break;
 
-                case OBJECT_ENTRY:
+                case OBJECT_ENTRY: {
+                        sd_id128_t boot_id;
+
                         if (JOURNAL_HEADER_SEALED(f->header) && n_tags <= 0) {
                                 error(p, "First entry before first tag");
                                 r = -EBADMSG;
@@ -1148,8 +1150,12 @@ int journal_file_verify(
                         entry_seqnum = le64toh(o->entry.seqnum);
                         entry_seqnum_set = true;
 
+                        r = journal_file_entry_boot_id(f, o, &boot_id);
+                        if (r < 0)
+                                return r;
+
                         if (entry_monotonic_set &&
-                            sd_id128_equal(entry_boot_id, o->entry.boot_id) &&
+                            sd_id128_equal(entry_boot_id, boot_id) &&
                             entry_monotonic > le64toh(o->entry.monotonic)) {
                                 error(p,
                                       "Entry timestamp out of synchronization (%"PRIu64" > %"PRIu64")",
@@ -1160,7 +1166,7 @@ int journal_file_verify(
                         }
 
                         entry_monotonic = le64toh(o->entry.monotonic);
-                        entry_boot_id = o->entry.boot_id;
+                        entry_boot_id = boot_id;
                         entry_monotonic_set = true;
 
                         if (!entry_realtime_set &&
@@ -1178,6 +1184,7 @@ int journal_file_verify(
 
                         n_entries++;
                         break;
+                }
 
                 case OBJECT_DATA_HASH_TABLE:
                         r = verify_hash_table(o, p, &n_data_hash_tables,
diff --git a/src/libsystemd/sd-journal/mmap-cache.h b/src/libsystemd/sd-journal/mmap-cache.h
index 7afb7f0..104b19d 100644
--- a/src/libsystemd/sd-journal/mmap-cache.h
+++ b/src/libsystemd/sd-journal/mmap-cache.h
@@ -5,7 +5,7 @@
 #include <sys/stat.h>
 
 /* One context per object type, plus one of the header, plus one "additional" one */
-#define MMAP_CACHE_MAX_CONTEXTS 11
+#define MMAP_CACHE_MAX_CONTEXTS 12
 
 typedef struct MMapCache MMapCache;
 typedef struct MMapFileDescriptor MMapFileDescriptor;
diff --git a/src/libsystemd/sd-journal/sd-journal.c b/src/libsystemd/sd-journal/sd-journal.c
index 14dbe58..0037da2 100644
--- a/src/libsystemd/sd-journal/sd-journal.c
+++ b/src/libsystemd/sd-journal/sd-journal.c
@@ -111,32 +111,45 @@ static void detach_location(sd_journal *j) {
                 journal_file_reset_location(f);
 }
 
-static void init_location(Location *l, LocationType type, JournalFile *f, Object *o) {
+static int init_location(Location *l, LocationType type, JournalFile *f, Object *o) {
+        sd_id128_t boot_id;
+        int r;
+
         assert(l);
         assert(IN_SET(type, LOCATION_DISCRETE, LOCATION_SEEK));
         assert(f);
 
+        r = journal_file_entry_boot_id(f, o, &boot_id);
+        if (r < 0)
+                return r;
+
         *l = (Location) {
                 .type = type,
                 .seqnum = le64toh(o->entry.seqnum),
                 .seqnum_id = f->header->seqnum_id,
                 .realtime = le64toh(o->entry.realtime),
                 .monotonic = le64toh(o->entry.monotonic),
-                .boot_id = o->entry.boot_id,
-                .xor_hash = le64toh(o->entry.xor_hash),
+                .boot_id = boot_id,
+                .xor_hash = journal_file_entry_xor_hash(f, o),
                 .seqnum_set = true,
                 .realtime_set = true,
                 .monotonic_set = true,
                 .xor_hash_set = true,
         };
+
+        return 0;
 }
 
-static void set_location(sd_journal *j, JournalFile *f, Object *o) {
+static int set_location(sd_journal *j, JournalFile *f, Object *o) {
+        int r;
+
         assert(j);
         assert(f);
         assert(o);
 
-        init_location(&j->current_location, LOCATION_DISCRETE, f, o);
+        r = init_location(&j->current_location, LOCATION_DISCRETE, f, o);
+        if (r < 0)
+                return r;
 
         j->current_file = f;
         j->current_field = 0;
@@ -144,6 +157,8 @@ static void set_location(sd_journal *j, JournalFile *f, Object *o) {
         /* Let f know its candidate entry was picked. */
         assert(f->location_type == LOCATION_SEEK);
         f->location_type = LOCATION_DISCRETE;
+
+        return 0;
 }
 
 static int match_is_valid(const void *data, size_t size) {
@@ -774,7 +789,9 @@ static int next_beyond_location(sd_journal *j, JournalFile *f, direction_t direc
                         if (r <= 0)
                                 return r;
 
-                        journal_file_save_location(f, c, cp);
+                        r = journal_file_save_location(f, c, cp);
+                        if (r < 0)
+                                return r;
                 }
         } else {
                 f->last_direction = direction;
@@ -783,7 +800,9 @@ static int next_beyond_location(sd_journal *j, JournalFile *f, direction_t direc
                 if (r <= 0)
                         return r;
 
-                journal_file_save_location(f, c, cp);
+                r = journal_file_save_location(f, c, cp);
+                if (r < 0)
+                        return r;
         }
 
         /* OK, we found the spot, now let's advance until an entry
@@ -864,7 +883,9 @@ static int real_journal_next(sd_journal *j, direction_t direction) {
         if (r < 0)
                 return r;
 
-        set_location(j, new_file, o);
+        r = set_location(j, new_file, o);
+        if (r < 0)
+                return r;
 
         return 1;
 }
@@ -920,6 +941,7 @@ _public_ int sd_journal_previous_skip(sd_journal *j, uint64_t skip) {
 }
 
 _public_ int sd_journal_get_cursor(sd_journal *j, char **cursor) {
+        sd_id128_t boot_id;
         Object *o;
         int r;
 
@@ -934,12 +956,16 @@ _public_ int sd_journal_get_cursor(sd_journal *j, char **cursor) {
         if (r < 0)
                 return r;
 
+        r = journal_file_entry_boot_id(j->current_file, o, &boot_id);
+        if (r < 0)
+                return r;
+
         if (asprintf(cursor,
                      "s=%s;i=%"PRIx64";b=%s;m=%"PRIx64";t=%"PRIx64";x=%"PRIx64,
                      SD_ID128_TO_STRING(j->current_file->header->seqnum_id), le64toh(o->entry.seqnum),
-                     SD_ID128_TO_STRING(o->entry.boot_id), le64toh(o->entry.monotonic),
+                     SD_ID128_TO_STRING(boot_id), le64toh(o->entry.monotonic),
                      le64toh(o->entry.realtime),
-                     le64toh(o->entry.xor_hash)) < 0)
+                     journal_file_entry_xor_hash(j->current_file, o)) < 0)
                 return -ENOMEM;
 
         return 0;
@@ -1047,8 +1073,9 @@ _public_ int sd_journal_seek_cursor(sd_journal *j, const char *cursor) {
 }
 
 _public_ int sd_journal_test_cursor(sd_journal *j, const char *cursor) {
-        int r;
+        sd_id128_t boot_id;
         Object *o;
+        int r;
 
         assert_return(j, -EINVAL);
         assert_return(!journal_pid_changed(j), -ECHILD);
@@ -1061,6 +1088,10 @@ _public_ int sd_journal_test_cursor(sd_journal *j, const char *cursor) {
         if (r < 0)
                 return r;
 
+        r = journal_file_entry_boot_id(j->current_file, o, &boot_id);
+        if (r < 0)
+                return r;
+
         for (;;) {
                 _cleanup_free_ char *item = NULL;
                 unsigned long long ll;
@@ -1098,7 +1129,7 @@ _public_ int sd_journal_test_cursor(sd_journal *j, const char *cursor) {
                         k = sd_id128_from_string(item+2, &id);
                         if (k < 0)
                                 return k;
-                        if (!sd_id128_equal(id, o->entry.boot_id))
+                        if (!sd_id128_equal(id, boot_id))
                                 return 0;
                         break;
 
@@ -1119,7 +1150,7 @@ _public_ int sd_journal_test_cursor(sd_journal *j, const char *cursor) {
                 case 'x':
                         if (sscanf(item+2, "%llx", &ll) != 1)
                                 return -EINVAL;
-                        if (ll != le64toh(o->entry.xor_hash))
+                        if (ll != journal_file_entry_xor_hash(j->current_file, o))
                                 return 0;
                         break;
                 }
@@ -2218,16 +2249,22 @@ _public_ int sd_journal_get_monotonic_usec(sd_journal *j, uint64_t *ret, sd_id12
         if (r < 0)
                 return r;
 
-        if (ret_boot_id)
-                *ret_boot_id = o->entry.boot_id;
-        else {
-                sd_id128_t id;
+        if (ret_boot_id) {
+                r = journal_file_entry_boot_id(f, o, ret_boot_id);
+                if (r < 0)
+                        return r;
+        } else {
+                sd_id128_t id, boot_id;
 
                 r = sd_id128_get_boot(&id);
                 if (r < 0)
                         return r;
 
-                if (!sd_id128_equal(id, o->entry.boot_id))
+                r = journal_file_entry_boot_id(f, o, &boot_id);
+                if (r < 0)
+                        return r;
+
+                if (!sd_id128_equal(id, boot_id))
                         return -ESTALE;
         }
 

